#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <stdint.h>

#define CODE_WORDS 2

unsigned int get_bit(void)
{
  return rand() < RAND_MAX/2;
}

// calculates the sum for the correlation: treats 0 as 1, -1 as 1
int bit_sum(unsigned int word) {
  int sum = 0;
  
  for (int bit_ix = 0; bit_ix < 32; bit_ix++) {
    if((word & 1) == 0) {
      // equivalent to 1
      sum++;
    } else {
      // equivalent to -1
      sum --;
    }
    // next bit
    word >>= 1;
  }

  return sum;
}

int main(void)
{
  int input_words = 4;
  uint32_t input_buffer[input_words];
  uint32_t const code[CODE_WORDS] = {0xc8be4789u, 0x4a35dd8};
  uint32_t xor_output[CODE_WORDS];

  sranddev();

  memset(input_buffer, 0, sizeof(input_buffer));
  memset(xor_output, 0, sizeof(xor_output));

  // read input
  /*
  for (int word_ix = 0; word_ix < input_words; word_ix++) {
    for (int bit_ix = 0; bit_ix < 32; bit_ix++) {
      input_buffer[word_ix] = (input_buffer[word_ix] << 1) | get_bit();
    }
    printf("0x%x\n", input_buffer[word_ix]);
  }
  */

  input_buffer[0] = 0;
  input_buffer[1] = 0xc8ba4789u;
  input_buffer[2] = 0x1a31dd8u;
  input_buffer[3] = 0;

  for (int shift = 0; shift < (input_words - CODE_WORDS) * 32; shift++) {
    int sum = 0;
    
    for (int word_ix = 0; word_ix < CODE_WORDS; word_ix++) {
      // bitwise XOR (equivalent to multiplication in (-1,+1))
      xor_output[word_ix] = input_buffer[word_ix] ^ code[word_ix];
      // sum up result
      sum += bit_sum(xor_output[word_ix]);
    }
    
    printf("sum: %i\n", sum);
    
    // shift input buffer
    input_buffer[0] = (input_buffer[0] << 1) | ((input_buffer[1] & (1ul << 31)) != 0);
    input_buffer[1] = (input_buffer[1] << 1) | ((input_buffer[2] & (1ul << 31)) != 0);
    input_buffer[2] = (input_buffer[2] << 1) | ((input_buffer[3] & (1ul << 31)) != 0);
    input_buffer[3] = input_buffer[3] << 1;
  }
  
  return 0;
}
