printf("Loading file %s... ", inputfile);
[received_samples, samplerate] = wavread(inputfile);
puts("done.\n");
received_samples = -received_samples';
% binarization
%received_samples = 2 * ((received_samples > 0) - 0.5);

received_samples = received_samples(1:100000);

chiprate = 8000;
codelength = 4000
load code.oct code
code = code(1:codelength);

factor = samplerate/chiprate;
code_interpolated = [];
for i=1:length(code),
  code_interpolated = [code_interpolated ones(1, factor) .* code(i)];
end

result = [];
% the frequency offsets are specific to my setup, try linspace(-0.001,0.001, 10)
freqoffsets = linspace(0.00090, 0.00102, 3)
for i=1:length(freqoffsets),
  printf("correlating (rate correction %f)... ", freqoffsets(i));
  % resample to remove freq. offset, re-binarize
  code_interpolated_resampled = (resample(code_interpolated, codelength * (1+freqoffsets(i)), codelength) > 0)*2 - 1;
  correlation = xcorr(received_samples, code_interpolated_resampled);
  result = [result; correlation];
  peak = max(correlation);
  threshold = peak * 0.6;
  noise = var(correlation(correlation < threshold));
  ratio = peak^2 / noise;
  % the dB value is just for comparison and doesn't have any meaning by itself
  printf("peak: %f, noise: %f, ratio: %f dB\n", peak, noise, 10 * log10(ratio));
end

peaks = max(result');
max_peak = max(peaks);
%figure
%plot(freqoffsets, peaks)
printf("Finished. Highest peak: %f\n", max_peak);

%figure;
%plot(freqoffsets, max(result'));
%title('peakhoehe in abhaengigkeit von frequenzkorrektur');

% plot result of second correlation
%figure
%plot(result(2,:))