#include <avr/io.h>
#include <avr/interrupt.h>
#include <stdint.h>
#include "m-seq.h"

#define F_CPU 8000000ul
#define CHIPRATE 8000

#define INCR_WITH_WRAP(var, max) (var == (max) ? var=0: var++)

/*
const uint8_t CODE[] = {0xAA};

ISR(TIMER1_COMPA_vect) {
  static uint8_t byte;
  static uint8_t bit;
  uint8_t output;

  output = (CODE[byte] >> bit) & 0x01; // 1 or 0
  PORTB = (output << PB0);

  INCR_WITH_WRAP(byte, sizeof(CODE) - 1);
  INCR_WITH_WRAP(bit, 7);
}
*/

ISR(TIMER1_COMPA_vect) {
  static uint8_t next_output = 0;
  static uint16_t n = 0;
  
  PORTB = (next_output << PB1);
  n++;
  if (n >= 4000) {
    seq_reset();
    n = 0;
  }
  next_output = seq_bit();
}

int main(void)
{
  // I/O
  DDRB = 0xFF;

  // Timer 1
  OCR1A = F_CPU/CHIPRATE; // compare value
  TCCR1B = (1 << CS10) | (1 << WGM12); // enable timer, no prescaler, clear on compare match
  TIMSK = (1 << OCIE1A); // enable compare A interrupt
  sei();
  
  while(1);
  return 0;
}
